/*
Copyright 2020 The Matrix.org Foundation C.I.C.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

import "../../dist/browser-matrix"; // uses browser-matrix instead of the src
import type { default as BrowserMatrix } from "../../src/browser-index";

// stub for browser-matrix browserify tests
// @ts-ignore
global.XMLHttpRequest = jest.fn();

afterAll(() => {
    // clean up XMLHttpRequest mock
    // @ts-ignore
    global.XMLHttpRequest = undefined;
});

// Akin to spec/setupTests.ts - but that won't affect the browser-matrix bundle
global.matrixcs = {
    ...global.matrixcs,
    timeoutSignal: () => new AbortController().signal,
} as typeof BrowserMatrix;
